#!/bin/bash
# This script performs the following actions:
#
# * Runs the generator, using example configuration json file
#
# * Builds the project using gradle
#
# * Copies generated iOS artifacts into the example project
#
# * Ensures the iOS example project compiles with the new code
#
set -e
./gradlew :smartype-generator:clean :smartype-generator:run
cp -r smartype-generator/dist/Smartype.framework examples/iosExample/FrameworkExample/
cd examples/iosExample
carthage bootstrap
xcodebuild -quiet -project FrameworkExample.xcodeproj -destination 'platform=iOS Simulator,name=iPhone X,OS=latest' -sdk iphonesimulator
code=$?
cd ../..
exit $code
